// Generated by CoffeeScript 1.12.7
var CustomDataTypeGeoref,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CustomDataTypeGeoref = (function(superClass) {
  extend(CustomDataTypeGeoref, superClass);

  function CustomDataTypeGeoref() {
    return CustomDataTypeGeoref.__super__.constructor.apply(this, arguments);
  }

  CustomDataTypeGeoref.prototype.getCustomDataTypeName = function() {
    return "custom:base.custom-data-type-georef.georef";
  };

  CustomDataTypeGeoref.prototype.getCustomDataTypeNameLocalized = function() {
    return $$("custom.data.type.georef.name");
  };

  CustomDataTypeGeoref.prototype.showEditPopover = function(btn, data, cdata, layout, opts) {
    var cdata_form, xmapboxpane;
    cdata_form = new CUI.Form({
      data: cdata,
      fields: this.__getEditorFields(cdata),
      onDataChanged: (function(_this) {
        return function() {
          _this.__updateResult(cdata, layout, opts);
          return _this.__setEditorFieldStatus(cdata, layout);
        };
      })(this)
    }).start();
    xmapboxpane = new CUI.SimplePane({
      "class": "georef_mapbox_container",
      header_left: new CUI.Label({
        text: "Satellit und Straßen"
      }),
      content: new CUI.Label({
        text: ""
      })
    });
    this.popover = new CUI.Popover({
      element: btn,
      fill_space: "both",
      placement: "c",
      pane: {
        header_left: new CUI.Label({
          text: $$('custom.data.type.georef.name')
        }),
        footer_right: [],
        footer_left: cdata_form,
        content: xmapboxpane
      },
      onHide: (function(_this) {
        return function() {
          return _this.__updateResult(cdata, layout, opts);
        };
      })(this)
    }).show();
    return this.__initMap(cdata, cdata_form, layout, opts);
  };

  CustomDataTypeGeoref.prototype.getMapboxAccessToken = function() {
    var mapbox_access_token, ref, ref1;
    mapbox_access_token = '';
    if ((ref = this.getCustomSchemaSettings().mapbox_access_token) != null ? ref.value : void 0) {
      mapbox_access_token = (ref1 = this.getCustomSchemaSettings().mapbox_access_token) != null ? ref1.value : void 0;
    } else {
      mapbox_access_token = false;
    }
    return mapbox_access_token;
  };

  CustomDataTypeGeoref.prototype.__initMap = function(cdata, cdata_form, layout, opts) {
    var container, data, draw, frontendLanguage, frontendLanguages, geoJSON, geocoder, i, map, ref, removeExistingFeatures, results, that, typebuttons;
    that = this;
    mapboxgl.accessToken = that.getMapboxAccessToken();
    container = document.getElementsByClassName('georef_mapbox_container')[0];
    container.removeAttribute('class');
    container.removeAttribute('style');
    container.removeAttribute('id');
    container.className = 'georef_mapbox_container';
    container.innerHTML = '';
    map = new mapboxgl.Map({
      container: container,
      style: 'mapbox://styles/mapbox/satellite-streets-v10',
      center: [9.935, 51.5338],
      zoom: 5,
      maxZoom: 20
    });
    map.dragRotate.disable();
    map.touchZoomRotate.disableRotation();
    if (((ref = this.getCustomSchemaSettings().use_geocoder) != null ? ref.value : void 0) === true) {
      frontendLanguage = frontendLanguages = ez5.loca.getLanguage();
      geocoder = new MapboxGeocoder({
        accessToken: mapboxgl.accessToken,
        language: frontendLanguage,
        marker: false,
        mapboxgl: mapboxgl
      });
      map.addControl(geocoder, 'top-left');
    }
    draw = new MapboxDraw({
      displayControlsDefault: false,
      controls: {
        polygon: true,
        point: true,
        line_string: true,
        trash: false
      }
    });
    map.addControl(draw);
    map.dragPan.enable();
    data = draw.getAll();
    if (cdata.conceptURI !== '' && cdata.conceptName !== '' && cdata.conceptURI !== void 0 && cdata.conceptName !== void 0) {
      geoJSON = JSON.parse(cdata.conceptURI);
      map.on('load', function() {
        map.addSource('Georeferenzierung', {
          'type': 'geojson',
          'data': geoJSON
        });
        that.addMapLayers(map, 'Georeferenzierung', 'Georeferenzierung', true);
        map.fitBounds(geojsonExtent(geoJSON), {
          padding: 20
        });
      });
    }
    map.on('click', function(e) {
      var coords, j, len, line, linePoints, polygonCoords, rewind, turfPolygon, type, value;
      data = draw.getAll();
      if (data.features.length === 1) {
        geoJSON = data.features[0];
        delete geoJSON.id;
        type = data.features[0].geometry.type;
        if (type === 'Point') {
          if (data.features[0].geometry.coordinates.length === 2) {
            geoJSON = JSON.stringify(geoJSON);
            coords = data.features[0].geometry.coordinates;
            coords = coords.join(' ');
            cdata.conceptURI = geoJSON;
            cdata.conceptName = 'Point';
          }
        }
        if (type === 'LineString') {
          if (data.features[0].geometry.coordinates.length >= 2) {
            geoJSON = JSON.stringify(geoJSON);
            line = data.features[0].geometry.coordinates;
            linePoints = new Array;
            for (j = 0, len = line.length; j < len; j++) {
              value = line[j];
              linePoints.push(value.join(' '));
            }
            linePoints = linePoints.join(',');
            cdata.conceptURI = geoJSON;
            cdata.conceptName = 'LineString';
          }
        }
        if (type === 'Polygon') {
          if (data.features[0].geometry.coordinates[0].length >= 5) {
            polygonCoords = data.features[0].geometry.coordinates;
            turfPolygon = turf.polygon.polygon(polygonCoords);
            rewind = turf.rewind(turfPolygon);
            geoJSON.geometry.coordinates = rewind.geometry.coordinates;
            geoJSON = JSON.stringify(geoJSON);
            cdata.conceptURI = geoJSON;
            cdata.conceptName = 'Polygon';
          }
        }
      }
    });
    typebuttons = document.getElementsByClassName('mapbox-gl-draw_ctrl-draw-btn');
    removeExistingFeatures = function() {
      cdata.conceptURI = '';
      cdata.conceptName = '';
      data = draw.getAll();
      return draw.deleteAll();
    };
    i = 0;
    results = [];
    while (i < typebuttons.length) {
      typebuttons[i].addEventListener('mousedown', removeExistingFeatures, false);
      results.push(i++);
    }
    return results;
  };

  CustomDataTypeGeoref.prototype.__getEditorFields = function(cdata) {
    var fields;
    fields = [];
    return fields;
  };

  CustomDataTypeGeoref.prototype.getDataStatus = function(cdata) {
    var exception, geoJSONCheck, json, typeCheck;
    if (cdata) {
      if (cdata.conceptURI && cdata.conceptName) {
        geoJSONCheck = 0;
        try {
          json = JSON.parse(cdata.conceptURI);
        } catch (error) {
          exception = error;
          json = null;
        }
        if (json) {
          geoJSONCheck = 1;
        }
        typeCheck = cdata.conceptName ? cdata.conceptName.trim() : void 0;
        if (geoJSONCheck && typeCheck) {
          return "ok";
        }
        if (cdata.conceptURI.trim() === '' && cdata.conceptName.trim() === '') {
          return "empty";
        }
        return "invalid";
      } else {
        cdata = {
          conceptName: '',
          conceptURI: ''
        };
        return "empty";
      }
    } else {
      cdata = {
        conceptName: '',
        conceptURI: ''
      };
      return "empty";
    }
  };

  CustomDataTypeGeoref.prototype.addMapLayers = function(map, source, id, interactive) {
    map.addLayer({
      'id': 'layerPolygon',
      'type': 'fill',
      'source': source,
      'interactive': interactive,
      'layout': {},
      'paint': {
        'fill-color': '#C20000',
        'fill-opacity': 0.5
      },
      'filter': ['==', '$type', 'Polygon']
    });
    map.addLayer({
      'id': 'layerLineString',
      'type': 'line',
      'source': source,
      'interactive': interactive,
      'layout': {
        'line-join': 'round',
        'line-cap': 'round'
      },
      'paint': {
        'line-color': '#C20000',
        'line-width': 4
      },
      'filter': ['==', '$type', 'LineString']
    });
    return map.addLayer({
      'id': 'layerPoint',
      'type': 'symbol',
      'source': source,
      'interactive': interactive,
      'layout': {
        'icon-image': 'embassy-15',
        'text-field': '',
        'text-font': ['Open Sans Semibold', 'Arial Unicode MS Bold'],
        'text-offset': [0, 0.6],
        'text-anchor': 'top'
      },
      'filter': ['==', '$type', 'Point']
    });
  };

  CustomDataTypeGeoref.prototype.initStaticMap = function(containerID, cdata, parentNode) {
    var container, that, timeout;
    that = this;
    timeout = 200;
    container = CUI.dom.findElement(parentNode.DOM, "#" + containerID);
    if (container) {
      timeout = 0;
    }
    return setTimeout(function() {
      var geoJSON, geojsonFromCdata, jsonStr, map, mapContent, mapbox_access_token;
      container = CUI.dom.findElement(parentNode.DOM, "#" + containerID);
      mapbox_access_token = that.getMapboxAccessToken();
      if (mapbox_access_token) {
        mapboxgl.accessToken = mapbox_access_token;
        mapContent = new CUI.Label({
          text: $$('custom.data.type.georef.edit.kartenansicht')
        });
        geojsonFromCdata = JSON.parse(cdata.conceptURI);
        if ((geojsonFromCdata != null ? geojsonFromCdata.type : void 0) !== "FeatureCollection") {
          jsonStr = '{"type": "FeatureCollection","features": []}';
          geoJSON = JSON.parse(jsonStr);
          geoJSON.features.push(geojsonFromCdata);
        } else {
          geoJSON = geojsonFromCdata;
        }
        map = new mapboxgl.Map({
          container: container,
          style: 'mapbox://styles/mapbox/satellite-streets-v10',
          center: [9.935, 51.5338],
          zoom: 5,
          maxZoom: 17,
          attributionControl: false,
          interactive: false
        });
        return map.on('load', function() {
          if (geojsonFromCdata) {
            map.addSource('Georeferenzierung', {
              'type': 'geojson',
              'data': geoJSON
            });
            that.addMapLayers(map, 'Georeferenzierung', 'Georeferenzierung', false);
            map.fitBounds(geojsonExtent(geoJSON), {
              padding: 20
            });
          }
          map.on('idle', function() {
            return map.resize();
          });
          return map.addControl(new mapboxgl.NavigationControl());
        });
      } else {
        return console.error("no mapbox-access-token for georef");
      }
    }, timeout);
  };

  CustomDataTypeGeoref.prototype.__updateResult = function(cdata, layout, opts) {
    var copyrightLabel, displayURI, info, inputX, mapPane, options, searchsuggest_xhr, suggest_Menu_directInput, that, uriParts, uuid;
    that = this;
    if (cdata != null ? cdata.conceptURI : void 0) {
      displayURI = cdata.conceptURI;
      displayURI = displayURI.replace('http://', '');
      displayURI = displayURI.replace('https://', '');
      uriParts = displayURI.split('/');
      uuid = uriParts.pop();
      if (uuid.length > 10) {
        uuid = uuid.substring(0, 5) + '…';
        uriParts.push(uuid);
        displayURI = uriParts.join('/');
      }
      copyrightLabel = new CUI.Label({
        text: "Copyright",
        size: "mini"
      });
      copyrightLabel.DOM.innerHTML = "©&nbsp;<a href='https://www.mapbox.com/about/maps/'>Mapbox</a>&nbsp;&nbsp;©&nbsp;<a href='http://www.openstreetmap.org/copyright'>OpenStreetMap</a>&nbsp;&nbsp;<strong><a href='https://www.mapbox.com/map-feedback/' target='_blank'>Improve this map</a></strong>";
      info = new CUI.VerticalLayout({
        "class": 'ez5-info_commonPlugin',
        top: {
          content: mapPane = new CUI.Pane({
            "class": "cui-mapbox-georef-pane",
            top: {
              content: [
                new CUI.PaneHeader({
                  left: {
                    content: new CUI.Label({
                      text: cdata.conceptName + ' (' + $$('custom.data.type.georef.edit.kartenansicht') + ')'
                    })
                  }
                })
              ]
            },
            center: {
              content: new CUI.SimplePane({
                id: "georef_mapbox_container_static",
                "class": "georef_mapbox_container_static",
                content: new CUI.Label({
                  text: ""
                })
              })
            },
            bottom: {
              content: [
                new CUI.PaneFooter({
                  left: {
                    content: copyrightLabel
                  },
                  right: {
                    content: ""
                  }
                })
              ]
            }
          })
        }
      });
      that.initStaticMap('georef_mapbox_container_static', cdata, layout);
      layout.replace(info, 'center');
      layout.addClass('ez5-linked-object-edit');
      options = {
        "class": 'ez5-linked-object-container'
      };
      layout.__initPane(options, 'center');
    }
    if (!(cdata != null ? cdata.conceptURI : void 0)) {
      suggest_Menu_directInput;
      inputX = new CUI.Input({
        "class": "pluginDirectSelectEditInput",
        undo_and_changed_support: false,
        name: "directSelectInput",
        content_size: false,
        onKeyup: (function(_this) {
          return function(input) {
            return input.setValue('');
          };
        })(this)
      });
      inputX.render();
      suggest_Menu_directInput = new CUI.Menu({
        element: inputX,
        use_element_width_as_min_width: true
      });
      searchsuggest_xhr = {
        "xhr": void 0
      };
      layout.replace(inputX, 'center');
      layout.removeClass('ez5-linked-object-edit');
      options = {
        "class": ''
      };
      layout.__initPane(options, 'center');
    }
    if (!(opts != null ? opts.deleteDataFromPlugin : void 0) === true) {
      return that.__setEditorFieldStatus(cdata, layout);
    }
  };

  CustomDataTypeGeoref.prototype.__renderButtonByData = function(cdata) {
    var copyrightLabel, mapPane, that;
    that = this;
    switch (this.getDataStatus(cdata)) {
      case "empty":
        return new CUI.EmptyLabel({
          text: $$("custom.data.type.georef.edit.no_georef")
        }).DOM;
      case "invalid":
        return new CUI.EmptyLabel({
          text: $$("custom.data.type.georef.edit.no_valid_georef")
        }).DOM;
    }
    copyrightLabel = new CUI.Label({
      text: "Copyright",
      size: "mini"
    });
    copyrightLabel.DOM.innerHTML = "©&nbsp;<a href='https://www.mapbox.com/about/maps/'>Mapbox</a>&nbsp;&nbsp;©&nbsp;<a href='http://www.openstreetmap.org/copyright'>OpenStreetMap</a>&nbsp;&nbsp;<strong><a href='https://www.mapbox.com/map-feedback/' target='_blank'>Improve this map</a></strong>";
    mapPane = new CUI.Pane({
      "class": "cui-mapbox-georef-pane",
      top: {
        content: [
          new CUI.PaneHeader({
            left: {
              content: new CUI.Label({
                text: cdata.conceptName + ' (' + $$('custom.data.type.georef.edit.kartenansicht') + ')'
              })
            },
            right: {
              content: [CUI.Pane.getToggleFillScreenButton()]
            }
          })
        ]
      },
      center: {
        content: new CUI.SimplePane({
          id: "georef_mapbox_container_static",
          "class": "georef_mapbox_container_static",
          content: new CUI.Label({
            text: ""
          })
        })
      },
      bottom: {
        content: [
          new CUI.PaneFooter({
            left: {
              content: copyrightLabel
            },
            right: {
              content: ""
            }
          })
        ]
      }
    });
    that.initStaticMap('georef_mapbox_container_static', cdata, mapPane);
    return mapPane.DOM;
  };

  CustomDataTypeGeoref.prototype.getCustomDataOptionsInDatamodelInfo = function(custom_settings) {
    var ref, ref1, tags;
    tags = [];
    if ((ref = custom_settings.mapbox_access_token) != null ? ref.value : void 0) {
      tags.push("✓ Mapbox-Access-Token");
    } else {
      tags.push("✘ Mapbox-Access-Token");
    }
    if ((ref1 = custom_settings.use_geocoder) != null ? ref1.value : void 0) {
      tags.push("✓ Geocoder");
    } else {
      tags.push("✘ Geocoder");
    }
    return tags;
  };

  return CustomDataTypeGeoref;

})(CustomDataTypeWithCommons);

CustomDataType.register(CustomDataTypeGeoref);
