// Generated by CoffeeScript 1.12.7
var CustomDataTypeCommonFacet, CustomDataTypeWithCommons,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CustomDataTypeWithCommons = (function(superClass) {
  extend(CustomDataTypeWithCommons, superClass);

  function CustomDataTypeWithCommons() {
    this.getQueryFieldBadge = bind(this.getQueryFieldBadge, this);
    return CustomDataTypeWithCommons.__super__.constructor.apply(this, arguments);
  }

  CustomDataTypeWithCommons.prototype.initData = function(data) {
    var cdata;
    if (!data[this.name()]) {
      cdata = {};
      data[this.name()] = cdata;
    } else {
      cdata = data[this.name()];
    }
    if (!cdata.url) {
      cdata.url = "";
    }
    return cdata;
  };

  CustomDataTypeWithCommons.prototype.renderFieldAsGroup = function() {
    return false;
  };

  CustomDataTypeWithCommons.prototype.renderRowAsBlock = function(data, top_level_data, opts) {
    return false;
  };

  CustomDataTypeWithCommons.prototype.getQueryFieldBadge = function(data) {
    var value;
    if (data[(this.name()) + ":unset"]) {
      value = $$("text.column.badge.without");
    } else {
      value = data[this.name()];
    }
    return {
      name: this.nameLocalized(),
      value: value
    };
  };

  CustomDataTypeWithCommons.prototype.supportsStandard = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.supportsPrinting = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.supportsFacet = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.getFacet = function(opts) {
    opts.field = this;
    return new CustomDataTypeCommonFacet(opts);
  };

  CustomDataTypeWithCommons.prototype.getSortFunction = function() {
    return (function(_this) {
      return function(a, b) {
        var ref, ref1;
        return CUI.util.compareIndex(((ref = a[_this.name()]) != null ? ref.conceptName : void 0) || 'zzz', ((ref1 = b[_this.name()]) != null ? ref1.conceptName : void 0) || 'zzz');
      };
    })(this);
  };

  CustomDataTypeWithCommons.prototype.hasRenderForSort = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.sortExtraOpts = function() {
    return [
      {
        text: "conceptName",
        value: "conceptName"
      }, {
        text: "conceptURI",
        value: "conceptURI"
      }
    ];
  };

  CustomDataTypeWithCommons.prototype.renderSearchInput = function(data, opts) {
    var search_token;
    if (opts == null) {
      opts = {};
    }
    return search_token = new SearchToken({
      column: this,
      data: data,
      fields: opts.fields
    }).getInput().DOM;
  };

  CustomDataTypeWithCommons.prototype.getFieldNamesForSearch = function() {
    return this.getFieldNames();
  };

  CustomDataTypeWithCommons.prototype.getFieldNamesForSuggest = function() {
    return this.getFieldNames();
  };

  CustomDataTypeWithCommons.prototype.getFieldNames = function() {
    var field_names;
    field_names = [this.fullName() + ".conceptURI", this.fullName() + ".conceptName"];
    return field_names;
  };

  CustomDataTypeWithCommons.prototype.getSearchFilter = function(data, key) {
    var filter, phrase, ref, str, val;
    if (key == null) {
      key = this.name();
    }
    if (data[key + ":unset"]) {
      filter = {
        type: "in",
        fields: [this.fullName() + ".conceptName"],
        "in": [null]
      };
      filter._unnest = true;
      filter._unset_filter = true;
      return filter;
    }
    filter = CustomDataTypeWithCommons.__super__.getSearchFilter.call(this, data, key);
    if (filter) {
      return filter;
    }
    if (CUI.util.isEmpty(data[key])) {
      return;
    }
    val = data[key];
    ref = Search.getPhrase(val), str = ref[0], phrase = ref[1];
    switch (data[key + ":type"]) {
      case "token":
      case "fulltext":
      case void 0:
        filter = {
          type: "match",
          mode: data[key + ":mode"],
          fields: this.getFieldNamesForSearch(),
          string: str,
          phrase: phrase
        };
        break;
      case "field":
        filter = {
          type: "in",
          fields: this.getFieldNamesForSearch(),
          "in": [str]
        };
    }
    return filter;
  };

  CustomDataTypeWithCommons.prototype.renderEditorInput = function(data, top_level_data, opts) {
    var name;
    name = this.name();
    if (!data[name]) {
      data[name] = {
        conceptName: '',
        conceptURI: ''
      };
    }
    return this.__renderEditorInputPopover(data, data[name], opts);
  };

  CustomDataTypeWithCommons.prototype.__renderEditorInputPopover = function(data, cdata, opts) {
    var classNameForBurgerMenuButton, layout, that;
    if (opts == null) {
      opts = {};
    }
    that = this;
    layout;
    classNameForBurgerMenuButton = 'pluginDirectSelectEditSearch';
    if (ez5.version("6")) {
      classNameForBurgerMenuButton = 'pluginDirectSelectEditSearchFylr';
    } else if (ez5.version("5")) {
      classNameForBurgerMenuButton = 'pluginDirectSelectEditSearch';
    }
    layout = new CUI.HorizontalLayout({
      "class": 'customPluginEditorLayout',
      center: {
        "class": ''
      },
      right: {
        content: new CUI.Buttonbar({
          buttons: [
            new CUI.Button({
              text: '',
              icon: new CUI.Icon({
                "class": "fa-ellipsis-v"
              }),
              "class": classNameForBurgerMenuButton,
              onClick: (function(_this) {
                return function(e, dotsButton) {
                  var deleteClear, detailinfo, dotsButtonMenu, itemList, menu_items, uriCall;
                  dotsButtonMenu = new CUI.Menu({
                    "class": "customDataTypeCommonsMenu",
                    element: dotsButton
                  }, menu_items = [
                    {
                      text: $$('custom.data.type.commons.controls.search.label'),
                      value: 'search',
                      icon_left: new CUI.Icon({
                        "class": "fa-search"
                      }),
                      onClick: function(e2, btn2) {
                        that.showEditPopover(dotsButton, data, cdata, layout, opts);
                        return dotsButtonMenu.hide();
                      }
                    }
                  ], typeof that.__getAdditionalTooltipInfo === "function" ? (detailinfo = {
                    text: $$('custom.data.type.commons.controls.detailinfo.label'),
                    value: 'detail',
                    icon_left: new CUI.Icon({
                      "class": "fa-info-circle"
                    }),
                    disabled: that.isEmpty(data, 0, 0),
                    onClick: function(eDetailInfo, btnDetailInfo) {
                      var tooltip;
                      tooltip = new CUI.Tooltip({
                        element: btnDetailInfo,
                        placement: 'w',
                        markdown: true,
                        show_ms: 1000,
                        hide_ms: 200,
                        content: function(tooltip) {
                          var encodedURI, extendedInfo_xhr;
                          if (!that.isEmpty(data, 0, 0)) {
                            encodedURI = encodeURIComponent(cdata.conceptURI);
                            extendedInfo_xhr = {
                              "xhr": void 0
                            };
                            that.__getAdditionalTooltipInfo(encodedURI, tooltip, extendedInfo_xhr);
                            return new CUI.Label({
                              icon: "spinner",
                              text: $$('custom.data.type.commons.modal.form.popup.loadingstring')
                            });
                          }
                        }
                      });
                      tooltip.show();
                      return CUI.Events.listen({
                        type: ["click", "dblclick", "mouseout"],
                        capture: true,
                        node: btnDetailInfo,
                        only_once: true,
                        call: (function(_this) {
                          return function(ev) {
                            return dotsButtonMenu.hide();
                          };
                        })(this)
                      });
                    }
                  }, menu_items.push(detailinfo)) : void 0, uriCall = {
                    text: $$('custom.data.type.commons.controls.calluri.label'),
                    value: 'uri',
                    icon_left: new CUI.Icon({
                      "class": "fa-external-link"
                    }),
                    disabled: that.isEmpty(data, 0, 0) || !CUI.parseLocation(cdata.conceptURI),
                    onClick: function() {
                      window.open(cdata.conceptURI, "_blank");
                      return dotsButtonMenu.hide();
                    }
                  }, menu_items.push(uriCall), deleteClear = {
                    text: $$('custom.data.type.commons.controls.delete.label'),
                    value: 'delete',
                    name: 'deleteValueFromDANTEPlugin',
                    "class": 'deleteValueFromDANTEPlugin',
                    icon_left: new CUI.Icon({
                      "class": "fa-trash"
                    }),
                    disabled: that.isEmpty(data, 0, 0),
                    onClick: function() {
                      cdata = {
                        conceptName: '',
                        conceptURI: ''
                      };
                      data[that.name()] = cdata;
                      that.__updateResult(cdata, layout, opts);
                      return dotsButtonMenu.hide();
                    }
                  }, menu_items.push(deleteClear), itemList = {
                    items: menu_items
                  });
                  dotsButtonMenu._auto_close_after_click = false;
                  dotsButtonMenu.setItemList(itemList);
                  return dotsButtonMenu.show();
                };
              })(this)
            })
          ]
        })
      }
    });
    CUI.Events.registerEvent({
      type: "custom-deleteDataFromPlugin",
      bubble: false
    });
    CUI.Events.listen({
      type: "custom-deleteDataFromPlugin",
      instance: that,
      node: layout,
      call: (function(_this) {
        return function() {
          cdata = {};
          data[that.name()] = cdata;
          opts.deleteDataFromPlugin = true;
          return that.__updateResult(cdata, layout, opts);
        };
      })(this)
    });
    this.__updateResult(cdata, layout, opts);
    return layout;
  };

  CustomDataTypeWithCommons.prototype.showEditPopover = function(btn, data, cdata, layout, opts) {
    var cdata_form, searchsuggest_xhr, suggest_Menu, that;
    that = this;
    suggest_Menu;
    searchsuggest_xhr = {
      "xhr": void 0
    };
    cdata.countOfSuggestions = 50;
    cdata_form = new CUI.Form({
      "class": 'cdtFormWithPadding',
      data: cdata,
      fields: that.__getEditorFields(cdata),
      onDataChanged: (function(_this) {
        return function(data, elem) {
          _this.__updateResult(cdata, layout, opts);
          _this.__setEditorFieldStatus(cdata, layout);
          return _this.__updateSuggestionsMenu(cdata, cdata_form, data.searchbarInput, elem, suggest_Menu, searchsuggest_xhr, layout, opts);
        };
      })(this)
    }).start();
    suggest_Menu = new CUI.Menu({
      element: cdata_form.getFieldsByName("searchbarInput")[0],
      use_element_width_as_min_width: true,
      "class": "customDataTypeCommonsMenu"
    });
    return this.popover = new CUI.Popover({
      element: btn,
      placement: "wn",
      "class": "commonPlugin_Popover",
      pane: {
        header_left: new CUI.Label({
          text: $$('custom.data.type.commons.popover.choose.label')
        }),
        content: cdata_form
      }
    }).show();
  };

  CustomDataTypeWithCommons.prototype.isEmpty = function(data, top_level_data, opts) {
    var ref, ref1;
    if (opts == null) {
      opts = {};
    }
    if ((opts != null ? opts.mode : void 0) === "expert") {
      if (typeof data[this.name()] === 'object') {
        return CUI.util.isEmpty(data[this.name()] != null);
      } else {
        return CUI.util.isEmpty((ref = data[this.name()]) != null ? ref.trim() : void 0);
      }
    }
    return !((ref1 = data[this.name()]) != null ? ref1.conceptName : void 0);
  };

  CustomDataTypeWithCommons.prototype.getSaveData = function(data, save_data, opts) {
    var cdata, conceptFulltext, conceptNameChosenByHand, conceptStandard, frontendLanguage, frontendLanguages, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, that;
    that = this;
    if (opts.demo_data) {
      return {
        conceptName: 'Example',
        conceptURI: 'https://example.com'
      };
    }
    cdata = data[this.name()] || ((ref = data._template) != null ? ref[this.name()] : void 0);
    switch (this.getDataStatus(cdata)) {
      case "invalid":
        if (opts.copy) {
          return save_data[this.name()] = null;
        } else {
          throw new InvalidSaveDataException();
        }
        break;
      case "empty":
        return save_data[this.name()] = null;
      case "ok":
        conceptFulltext = {};
        if (cdata != null ? cdata._fulltext : void 0) {
          if ((ref1 = cdata._fulltext) != null ? ref1.string : void 0) {
            if (((ref2 = cdata._fulltext) != null ? ref2.string : void 0) !== '') {
              conceptFulltext.string = cdata._fulltext.string;
            }
          }
          if ((ref3 = cdata._fulltext) != null ? ref3.l10ntext : void 0) {
            if (cdata._fulltext.l10ntext) {
              conceptFulltext.l10ntext = cdata._fulltext.l10ntext;
            }
          }
          if ((ref4 = cdata._fulltext) != null ? ref4.text : void 0) {
            if (cdata._fulltext.text) {
              conceptFulltext.text = cdata._fulltext.text;
            }
          }
        } else {
          conceptFulltext.text = cdata.conceptName.trim();
        }
        conceptStandard = {};
        if (cdata != null ? cdata._standard : void 0) {
          if ((ref5 = cdata._standard) != null ? ref5.l10ntext : void 0) {
            if (cdata._standard.l10ntext) {
              conceptStandard.l10ntext = cdata._standard.l10ntext;
            }
          } else {
            if ((ref6 = cdata._standard) != null ? ref6.text : void 0) {
              if (((ref7 = cdata._standard) != null ? ref7.text : void 0) !== '') {
                conceptStandard.text = cdata._standard.text;
              }
            }
          }
        }
        frontendLanguages = ez5.loca.getLanguage();
        frontendLanguages = frontendLanguages.split('-');
        frontendLanguage = frontendLanguages[0];
        conceptNameChosenByHand = false;
        if (cdata != null ? cdata.conceptNameChosenByHand : void 0) {
          if (cdata.conceptNameChosenByHand === true) {
            conceptNameChosenByHand = true;
          }
        }
        save_data[this.name()] = {
          conceptName: cdata.conceptName.trim(),
          conceptURI: cdata.conceptURI.trim(),
          frontendLanguage: frontendLanguage,
          _fulltext: conceptFulltext,
          _standard: conceptStandard
        };
        if (cdata != null ? cdata.conceptAncestors : void 0) {
          if (cdata.conceptAncestors.length > 0) {
            if (Array.isArray(cdata.conceptAncestors)) {
              cdata.conceptAncestors = cdata.conceptAncestors.join(' ');
            }
            save_data[this.name()]['conceptAncestors'] = cdata.conceptAncestors;
          }
        }
        if (cdata != null ? cdata.conceptNameChosenByHand : void 0) {
          if (cdata.conceptNameChosenByHand === true) {
            save_data[this.name()]['conceptNameChosenByHand'] = true;
          }
        }
        if (cdata != null ? cdata.facetTerm : void 0) {
          return save_data[this.name()]['facetTerm'] = cdata.facetTerm;
        }
    }
  };

  CustomDataTypeWithCommons.prototype.__updateResult = function(cdata, layout, opts) {
    var displayURI, info, inputX, options, searchsuggest_xhr, suggest_Menu_directInput, that;
    that = this;
    if (opts.data) {
      opts.data[that.name(opts)] = cdata;
    }
    if (cdata != null ? cdata.conceptURI : void 0) {
      displayURI = cdata.conceptURI;
      if (displayURI.length > 20) {
        displayURI = displayURI.replace('http://', '');
        displayURI = displayURI.replace('https://', '');
      }
      if (displayURI.length > 30) {
        displayURI = displayURI.replace('uri.gbv.de/terminology/', '…/');
      }
      info = new CUI.VerticalLayout({
        "class": 'ez5-info_commonPlugin',
        top: {
          content: new CUI.Label({
            text: cdata.conceptName,
            multiline: true
          })
        },
        bottom: {
          content: new CUI.Button({
            name: "outputButtonHref",
            appearance: "flat",
            size: "normal",
            text: displayURI,
            tooltip: {
              markdown: true,
              placement: 'w',
              content: function(tooltip) {
                var encodedURI, extendedInfo_xhr;
                encodedURI = encodeURIComponent(cdata.conceptURI);
                extendedInfo_xhr = {
                  "xhr": void 0
                };
                if (typeof that.__getAdditionalTooltipInfo === "function") {
                  that.__getAdditionalTooltipInfo(encodedURI, tooltip, extendedInfo_xhr);
                  return new CUI.Label({
                    icon: "spinner",
                    text: $$('custom.data.type.commons.modal.form.popup.loadingstring')
                  });
                }
              }
            },
            onClick: (function(_this) {
              return function(evt, button) {
                return window.open(cdata.conceptURI, "_blank");
              };
            })(this)
          })
        }
      });
      layout.replace(info, 'center');
      layout.addClass('ez5-linked-object-edit');
      options = {
        "class": 'ez5-linked-object-container'
      };
      layout.__initPane(options, 'center');
    }
    if (!(cdata != null ? cdata.conceptURI : void 0)) {
      suggest_Menu_directInput;
      inputX = new CUI.Input({
        "class": "pluginDirectSelectEditInput",
        undo_and_changed_support: false,
        name: "directSelectInput",
        content_size: false,
        onKeyup: (function(_this) {
          return function(input) {
            var searchstring;
            searchstring = input.getValueForInput();
            if (typeof that.__updateSuggestionsMenu === "function") {
              return _this.__updateSuggestionsMenu(cdata, 0, searchstring, input, suggest_Menu_directInput, searchsuggest_xhr, layout, opts);
            }
          };
        })(this)
      });
      if (!(opts != null ? opts.callfrompoolmanager : void 0)) {
        inputX.render();
      }
      suggest_Menu_directInput = new CUI.Menu({
        element: inputX,
        use_element_width_as_min_width: true,
        "class": "customDataTypeCommonsMenu"
      });
      searchsuggest_xhr = {
        "xhr": void 0
      };
      layout.replace(inputX, 'center');
      layout.removeClass('ez5-linked-object-edit');
      options = {
        "class": ''
      };
      layout.__initPane(options, 'center');
    }
    if (!opts.deleteDataFromPlugin) {
      return that.__setEditorFieldStatus(cdata, layout);
    }
  };

  CustomDataTypeWithCommons.prototype.__setEditorFieldStatus = function(cdata, element) {
    switch (this.getDataStatus(cdata)) {
      case "invalid":
        element.addClass("cui-input-invalid");
        break;
      default:
        element.removeClass("cui-input-invalid");
    }
    CUI.Events.trigger({
      node: element,
      type: "editor-changed"
    });
    CUI.Events.trigger({
      node: element,
      type: "data-changed"
    });
    return this;
  };

  CustomDataTypeWithCommons.prototype.renderDetailOutput = function(data, top_level_data, opts) {
    return this.__renderButtonByData(data[this.name()]);
  };

  CustomDataTypeWithCommons.prototype.getDataStatus = function(cdata) {
    var nameCheck, uriCheck;
    if (cdata) {
      if (cdata.conceptURI && cdata.conceptName) {
        uriCheck = CUI.parseLocation(cdata.conceptURI);
        nameCheck = cdata.conceptName ? cdata.conceptName.trim() : void 0;
        if (uriCheck && nameCheck) {
          return "ok";
        }
        if (cdata.conceptURI.trim() === '' && cdata.conceptName.trim() === '') {
          return "empty";
        }
        return "invalid";
      }
    }
    return "empty";
  };

  return CustomDataTypeWithCommons;

})(CustomDataType);

CustomDataTypeCommonFacet = (function(superClass) {
  extend(CustomDataTypeCommonFacet, superClass);

  function CustomDataTypeCommonFacet() {
    return CustomDataTypeCommonFacet.__super__.constructor.apply(this, arguments);
  }

  CustomDataTypeCommonFacet.prototype.initOpts = function() {
    CustomDataTypeCommonFacet.__super__.initOpts.call(this);
    return this.addOpts({
      field: {
        mandatory: true,
        check: Field
      }
    });
  };

  CustomDataTypeCommonFacet.prototype.requestFacetWithLimit = function(obj) {
    return {
      limit: this.getLimit(),
      field: this._field.fullName() + ".conceptName",
      sort: "count",
      type: "term"
    };
  };

  CustomDataTypeCommonFacet.prototype.getObjects = function(key, data) {
    var ref;
    if (key == null) {
      key = this.name();
    }
    if (data == null) {
      data = this.data();
    }
    return ((ref = data[key]) != null ? ref.terms : void 0) || [];
  };

  CustomDataTypeCommonFacet.prototype.renderObjectText = function(object) {
    return object.term;
  };

  CustomDataTypeCommonFacet.prototype.getObjectPath = function(obj) {
    return [obj.term];
  };

  CustomDataTypeCommonFacet.prototype.name = function() {
    return this._field.fullName() + ".conceptName";
  };

  CustomDataTypeCommonFacet.prototype.requestSearchFilter = function(obj) {
    return {
      bool: "must",
      fields: [this._field.fullName() + ".conceptName"],
      type: "in",
      "in": [obj.term]
    };
  };

  return CustomDataTypeCommonFacet;

})(FieldFacet);
// Generated by CoffeeScript 1.12.7
var CustomDataTypeNomisma,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CustomDataTypeNomisma = (function(superClass) {
  extend(CustomDataTypeNomisma, superClass);

  function CustomDataTypeNomisma() {
    return CustomDataTypeNomisma.__super__.constructor.apply(this, arguments);
  }

  CustomDataTypeNomisma.prototype.getCustomDataTypeName = function() {
    return "custom:base.custom-data-type-nomisma.nomisma";
  };

  CustomDataTypeNomisma.prototype.getCustomDataTypeNameLocalized = function() {
    return $$("custom.data.type.nomisma.name");
  };

  CustomDataTypeNomisma.prototype.getFrontendLanguage = function() {
    var desiredLanguage;
    desiredLanguage = ez5.loca.getLanguage();
    desiredLanguage = desiredLanguage.split('-');
    desiredLanguage = desiredLanguage[0];
    return desiredLanguage;
  };

  CustomDataTypeNomisma.prototype.__getAdditionalTooltipInfo = function(uri, tooltip, extendedInfo_xhr) {
    var nomismaID, nomismaType, path, that;
    that = this;
    uri = decodeURIComponent(uri);
    if (extendedInfo_xhr.xhr !== void 0) {
      extendedInfo_xhr.xhr.abort();
    }
    nomismaID = uri;
    nomismaID = nomismaID.split('/');
    nomismaID = nomismaID.pop();
    nomismaType = uri;
    nomismaType = nomismaType.split('/');
    nomismaType.shift();
    nomismaType.shift();
    nomismaType.shift();
    nomismaType = nomismaType.shift();
    path = location.protocol + '//uri.gbv.de/terminology/' + nomismaType + '/' + nomismaID + '?format=json';
    extendedInfo_xhr.xhr = new CUI.XHR({
      url: path
    });
    extendedInfo_xhr.xhr.start().done(function(data, status, statusText) {
      var entry, htmlContent, i, j, key, key2, keyUpperCased, len, len1, value;
      htmlContent = '<span style="font-weight: bold; padding: 3px 6px;">' + $$('custom.data.type.goobi.config.parameter.mask.infopopup.popup.info') + '</span>';
      htmlContent += '<table style="border-spacing: 10px; border-collapse: separate;">';
      if (data != null ? data.uri : void 0) {
        for (key in data) {
          value = data[key];
          if (key !== '@context' && key !== 'inScheme' && key !== 'depiction' && key !== 'notation' && key !== 'Moodifizierungsdatum' && key !== 'uri') {
            keyUpperCased = key.charAt(0).toUpperCase() + key.slice(1);
            htmlContent += '<tr><td style="min-width:150px;"><b>' + keyUpperCased + ':</b></td><td>';
            for (key2 = i = 0, len = value.length; i < len; key2 = ++i) {
              entry = value[key2];
              htmlContent += entry;
            }
            htmlContent += '</td></tr>';
          }
          if (key === 'depiction') {
            htmlContent += '<tr><td style="min-width:150px;"><br /><b>Examples of this type:</b></td><td></td></tr><tr><td colspan="2">';
            for (key2 = j = 0, len1 = value.length; j < len1; key2 = ++j) {
              entry = value[key2];
              htmlContent += '<img src="' + entry + '" class="nomisma_imageExample" />';
            }
            htmlContent += '</td></tr>';
          }
        }
        htmlContent += '</table>';
      }
      tooltip.DOM.innerHTML = htmlContent;
      return tooltip.autoSize();
    });
  };

  CustomDataTypeNomisma.prototype.__updateSuggestionsMenu = function(cdata, cdata_form, nomisma_searchterm, input, suggest_Menu, searchsuggest_xhr, layout, opts) {
    var delayMillisseconds, that;
    that = this;
    delayMillisseconds = 200;
    return setTimeout((function() {
      var extendedInfo_xhr, nomisma_countSuggestions, nomisma_set, ref, ref1, ref2, ref3, ref4, ref5;
      if (cdata_form) {
        nomisma_searchterm = cdata_form.getFieldsByName("searchbarInput")[0].getValue();
        nomisma_countSuggestions = cdata_form.getFieldsByName("countOfSuggestions")[0].getValue();
        nomisma_set = cdata_form.getFieldsByName("searchSetSelect")[0].getValue();
      } else {
        nomisma_countSuggestions = 20;
        if ((ref = that.getCustomSchemaSettings().crro) != null ? ref.value : void 0) {
          nomisma_set = 'crro';
        } else if ((ref1 = that.getCustomSchemaSettings().ocre) != null ? ref1.value : void 0) {
          nomisma_set = 'ocre';
        } else if ((ref2 = that.getCustomSchemaSettings().aod) != null ? ref2.value : void 0) {
          nomisma_set = 'aod';
        } else if ((ref3 = that.getCustomSchemaSettings().sco) != null ? ref3.value : void 0) {
          nomisma_set = 'sco';
        } else if ((ref4 = that.getCustomSchemaSettings().pella) != null ? ref4.value : void 0) {
          nomisma_set = 'pella';
        } else if ((ref5 = that.getCustomSchemaSettings().pco) != null ? ref5.value : void 0) {
          nomisma_set = 'pco';
        }
      }
      if (nomisma_searchterm.length === 0) {
        return;
      }
      if (searchsuggest_xhr.xhr !== void 0) {
        searchsuggest_xhr.xhr.abort();
      }
      extendedInfo_xhr = {
        "xhr": void 0
      };
      if (searchsuggest_xhr.xhr !== void 0) {
        searchsuggest_xhr.xhr.abort();
      }
      searchsuggest_xhr.xhr = new CUI.XHR({
        url: location.protocol + '//ws.gbv.de/suggest/numismatics.org/?searchstring=' + nomisma_searchterm + '&type=' + nomisma_set + '&count=' + nomisma_countSuggestions
      });
      return searchsuggest_xhr.xhr.start().done(function(data, status, statusText) {
        var fn, i, itemList, key, len, menu_items, ref6, suggestion;
        menu_items = [];
        ref6 = data[1];
        fn = function(key) {
          var item;
          item = {
            text: suggestion,
            value: data[3][key],
            tooltip: {
              markdown: true,
              placement: "w",
              content: function(tooltip) {
                that.__getAdditionalTooltipInfo(data[3][key], tooltip, extendedInfo_xhr);
                return new CUI.Label({
                  icon: "spinner",
                  text: $$('custom.data.type.nomisma.modal.form.popup.loadingstring')
                });
              }
            }
          };
          return menu_items.push(item);
        };
        for (key = i = 0, len = ref6.length; i < len; key = ++i) {
          suggestion = ref6[key];
          fn(key);
        }
        itemList = {
          onClick: function(ev2, btn) {
            var dataEntry_xhr, nomismaID, nomismaType, path;
            cdata.conceptURI = btn.getOpt("value");
            cdata.conceptName = btn.getText();
            cdata.conceptFulltext = cdata.conceptName;
            nomismaID = cdata.conceptURI;
            nomismaID = nomismaID.split('/');
            nomismaID = nomismaID.pop();
            nomismaType = cdata.conceptURI;
            nomismaType = nomismaType.split('/');
            nomismaType.shift();
            nomismaType.shift();
            nomismaType.shift();
            nomismaType = nomismaType.shift();
            path = '//uri.gbv.de/terminology/' + nomismaType + '/' + nomismaID + '?format=json';
            dataEntry_xhr = new CUI.XHR({
              url: location.protocol + path
            });
            return dataEntry_xhr.start().done(function(data, status, statusText) {
              var fulltext;
              fulltext = '';
              if (data != null ? data.Titel : void 0) {
                fulltext += ' ' + data.Titel;
              }
              if (data != null ? data.Nominale : void 0) {
                fulltext += ' ' + data.Nominale;
              }
              if (data != null ? data.notation : void 0) {
                fulltext += ' ' + data.notation.join(' ');
              }
              if (data != null ? data.identifier : void 0) {
                fulltext += ' ' + data.identifier.join(' ');
              }
              cdata.conceptFulltext = fulltext;
              that.__updateResult(cdata, layout, opts);
              suggest_Menu.hide();
              if (that.popover) {
                return that.popover.hide();
              }
            });
          },
          items: menu_items
        };
        if (itemList.items.length === 0) {
          itemList = {
            items: [
              {
                text: $$('custom.data.type.nomisma.no_hit'),
                value: void 0
              }
            ]
          };
        }
        suggest_Menu.setItemList(itemList);
        return suggest_Menu.show();
      });
    }), delayMillisseconds);
  };

  CustomDataTypeNomisma.prototype.__getEditorFields = function(cdata) {
    var fields, option, ref, ref1, ref2, ref3, ref4, ref5, searchOptions;
    searchOptions = [];
    if ((ref = this.getCustomSchemaSettings().crro) != null ? ref.value : void 0) {
      option = {
        value: 'crro',
        text: $$('custom.data.type.nomisma.config.parameter.schema.crro.value.label_long')
      };
      searchOptions.push(option);
    }
    if ((ref1 = this.getCustomSchemaSettings().ocre) != null ? ref1.value : void 0) {
      option = {
        value: 'ocre',
        text: $$('custom.data.type.nomisma.config.parameter.schema.ocre.value.label_long')
      };
      searchOptions.push(option);
    }
    if ((ref2 = this.getCustomSchemaSettings().aod) != null ? ref2.value : void 0) {
      option = {
        value: 'aod',
        text: $$('custom.data.type.nomisma.config.parameter.schema.aod.value.label_long')
      };
      searchOptions.push(option);
    }
    if ((ref3 = this.getCustomSchemaSettings().sco) != null ? ref3.value : void 0) {
      option = {
        value: 'sco',
        text: $$('custom.data.type.nomisma.config.parameter.schema.sco.value.label_long')
      };
      searchOptions.push(option);
    }
    if ((ref4 = this.getCustomSchemaSettings().pella) != null ? ref4.value : void 0) {
      option = {
        value: 'pella',
        text: $$('custom.data.type.nomisma.config.parameter.schema.pella.value.label_long')
      };
      searchOptions.push(option);
    }
    if ((ref5 = this.getCustomSchemaSettings().pco) != null ? ref5.value : void 0) {
      option = {
        value: 'pco',
        text: $$('custom.data.type.nomisma.config.parameter.schema.pco.value.label_long')
      };
      searchOptions.push(option);
    }
    fields = [
      {
        type: CUI.Select,
        "class": "commonPlugin_Select",
        undo_and_changed_support: false,
        form: {
          label: $$('custom.data.type.nomisma.modal.form.text.count')
        },
        options: [
          {
            value: 10,
            text: '10 ' + $$('custom.data.type.nomisma.modal.form.text.count_short')
          }, {
            value: 20,
            text: '20 ' + $$('custom.data.type.nomisma.modal.form.text.count_short')
          }, {
            value: 50,
            text: '50 ' + $$('custom.data.type.nomisma.modal.form.text.count_short')
          }, {
            value: 100,
            text: '100 ' + $$('custom.data.type.nomisma.modal.form.text.count_short')
          }, {
            value: 500,
            text: '500 ' + $$('custom.data.type.nomisma.modal.form.text.count_short')
          }
        ],
        name: 'countOfSuggestions'
      }, {
        type: CUI.Select,
        "class": "commonPlugin_Select",
        undo_and_changed_support: false,
        form: {
          label: $$('custom.data.type.nomisma.modal.form.text.searchfield')
        },
        options: searchOptions,
        name: 'searchSetSelect'
      }, {
        type: CUI.Input,
        "class": "commonPlugin_Input",
        undo_and_changed_support: false,
        form: {
          label: $$("custom.data.type.nomisma.modal.form.text.searchbar")
        },
        placeholder: $$("custom.data.type.nomisma.modal.form.text.searchbar.placeholder"),
        name: "searchbarInput"
      }
    ];
    return fields;
  };

  CustomDataTypeNomisma.prototype.__renderButtonByData = function(cdata) {
    var extendedInfo_xhr, that;
    that = this;
    switch (this.getDataStatus(cdata)) {
      case "empty":
        return new CUI.EmptyLabel({
          text: $$("custom.data.type.nomisma.edit.no_nomisma")
        }).DOM;
      case "invalid":
        return new CUI.EmptyLabel({
          text: $$("custom.data.type.nomisma.edit.no_valid_nomisma")
        }).DOM;
    }
    extendedInfo_xhr = {
      "xhr": void 0
    };
    cdata.conceptURI = CUI.parseLocation(cdata.conceptURI).url;
    return new CUI.HorizontalLayout({
      maximize: true,
      left: {
        content: new CUI.Label({
          centered: false,
          text: cdata.conceptName
        })
      },
      center: {
        content: new CUI.Button({
          appearance: "link",
          icon_left: new CUI.Icon({
            "class": "fa-info-circle"
          }),
          tooltip: {
            markdown: true,
            placement: 'w',
            content: function(tooltip) {
              var uri;
              uri = cdata.conceptURI;
              that.__getAdditionalTooltipInfo(uri, tooltip, extendedInfo_xhr);
              return new CUI.Label({
                icon: "spinner",
                text: $$('custom.data.type.nomisma.modal.form.popup.loadingstring')
              });
            }
          },
          text: ""
        })
      },
      right: null
    }).DOM;
  };

  CustomDataTypeNomisma.prototype.getCustomDataOptionsInDatamodelInfo = function(custom_settings) {
    this;
    var ref, ref1, ref2, ref3, ref4, ref5, tags;
    tags = [];
    if ((ref = custom_settings.crro) != null ? ref.value : void 0) {
      tags.push("✓ CRRO");
    } else {
      tags.push("✘ CRRO");
    }
    if ((ref1 = custom_settings.ocre) != null ? ref1.value : void 0) {
      tags.push("✓ OCRE");
    } else {
      tags.push("✘ OCRE");
    }
    if ((ref2 = custom_settings.aod) != null ? ref2.value : void 0) {
      tags.push("✓ AOD");
    } else {
      tags.push("✘ AOD");
    }
    if ((ref3 = custom_settings.pco) != null ? ref3.value : void 0) {
      tags.push("✓ PCO");
    } else {
      tags.push("✘ PCO");
    }
    if ((ref4 = custom_settings.pella) != null ? ref4.value : void 0) {
      tags.push("✓ PELLA");
    } else {
      tags.push("✘ PELLA");
    }
    if ((ref5 = custom_settings.sco) != null ? ref5.value : void 0) {
      tags.push("✓ SCO");
    } else {
      tags.push("✘ SCO");
    }
    return tags;
  };

  return CustomDataTypeNomisma;

})(CustomDataTypeWithCommons);

CustomDataType.register(CustomDataTypeNomisma);
